/* 
 *  gstalker stock charter
 * 
 *  Copyright (c) 1998 Stefan S. Stratigakos
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, 
 *  USA.
 */

#include "myheader.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <dirent.h>


/*************************************************************************************/
void yes_delete_group()
{
	extern GtkWidget *workwith_groups_clist;
	extern char *global_string;
	extern exit_yesno_window();
	extern int global_int;
	
	
	unlink(global_string);
	gtk_clist_remove(GTK_CLIST(workwith_groups_clist), global_int);
	exit_yesno_window();
}
/*************************************************************************************/
void ok_rename_group()
{
	struct dirent **dirlist;
	int tint, tint2;
	FILE *infile;
	char tstring[250], tstring2[250], *tstringpointer, *line[1];
	extern GtkWidget *rename_group_value_entry, *workwith_groups_clist;
    	extern char *grouppath, *error_message, *global_string, nothing_entered[];
    	extern char invalid_entry[], already_exists[];
    	extern display_message(), exit_rename_group_window();
	
	
	tstringpointer = gtk_entry_get_text(GTK_ENTRY(rename_group_value_entry));
	tstring[0] = 0;
	sscanf(tstringpointer, "%s", tstring);
	tint = strlen(tstring);
	if (tint == 0)
	{
		error_message = nothing_entered;
		display_message();
		return;
	}
	if ((tstring[tint - 1] == '/') || (tstring[tint - 1] == '.'))
	{
		error_message = invalid_entry;
		display_message();
		return;
	}
	strcpy(tstring2, grouppath);
	strcat(tstring2, tstring);
	infile = fopen(tstring2, "r");
	if (infile)
	{
		fclose(infile);
		error_message = already_exists;
		display_message();
		return;
	}
	strcpy(tstring, grouppath);
	strcat(tstring, global_string);
	strcpy(tstring2, grouppath);
	strcat(tstring2, tstringpointer);
	rename(tstring, tstring2);
	
	gtk_clist_freeze (GTK_CLIST (workwith_groups_clist));
	gtk_clist_clear(GTK_CLIST(workwith_groups_clist));
	tint = scandir(grouppath, &dirlist, NULL, alphasort);
	tint2 = tint;
	for (tint = 2; tint < tint2; tint++)
	{
		strcpy(tstring, dirlist[tint]->d_name); 
   		line[0] = tstring;
		gtk_clist_append (GTK_CLIST (workwith_groups_clist), line);
	}
	gtk_clist_thaw (GTK_CLIST (workwith_groups_clist));
	exit_rename_group_window();
}
/*************************************************************************************/
void rename_group()
{
	int tint;
	GList *list;
	gchar *tstringpointer, tstring[250];
    	GtkWidget *vbox, *hbox, *label, *button, *button2, *hsep, *status, *hbox2, *hbox3;
    	GtkWidget *label2, *vbox2, *button3;
	extern GtkWidget *workwith_groups_clist, *rename_group_window, *rename_group_value_entry;
    	extern exit_rename_group_window(), display_message(), exit_workwith_groups_window();
    	extern help_rename_group_window();
    	extern char *global_string, *error_message, nothing_selected[];
    	extern int rename_group_flag;
    	
	
	if (rename_group_flag)
		return;
	list = GTK_CLIST (workwith_groups_clist)->selection;
    	if (! list)
    	{
    		error_message = nothing_selected;
		display_message();
		return;
	}
	tint = (int) list->data;
	gtk_clist_get_text (GTK_CLIST (workwith_groups_clist), tint, 0, &tstringpointer);
	if (global_string != NULL)
		free(global_string);
	strcpy(tstring, tstringpointer);
	global_string = (char *)malloc(sizeof(tstring) + 1);
	strcpy(global_string, tstring);
    		
	rename_group_window = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_signal_connect (GTK_OBJECT (rename_group_window), "delete_event",
			    GTK_SIGNAL_FUNC (exit_rename_group_window), NULL);
	gtk_signal_connect (GTK_OBJECT (rename_group_window), "destroy",
			    GTK_SIGNAL_FUNC (exit_rename_group_window), NULL);
	gtk_window_position(GTK_WINDOW (rename_group_window), GTK_WIN_POS_CENTER);
	gtk_window_set_title (GTK_WINDOW (rename_group_window), "Rename Group");
	gtk_container_border_width (GTK_CONTAINER (rename_group_window), 0);
	gtk_widget_set_usize(GTK_WIDGET (rename_group_window), 300, 0);
	
	vbox = gtk_vbox_new (FALSE, 0);
     	gtk_container_border_width (GTK_CONTAINER (vbox), 0);
      	gtk_container_add (GTK_CONTAINER (rename_group_window), vbox);
      	gtk_widget_show (vbox);
      	
      	vbox2 = gtk_vbox_new (FALSE, 10);
     	gtk_container_border_width (GTK_CONTAINER (vbox2), 0);
     	gtk_box_pack_start (GTK_BOX (vbox), vbox2, FALSE, TRUE, 10);
      	gtk_widget_show (vbox2);
      		
     	hbox = gtk_hbox_new(FALSE, 0);
        gtk_container_border_width (GTK_CONTAINER (hbox), 0);
        gtk_box_pack_start (GTK_BOX (vbox2), hbox, FALSE, TRUE, 0);
      	gtk_widget_show(hbox);
      		
      	label = gtk_label_new("Old:  ");
	gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, TRUE, 10);
        gtk_widget_show(label);
        	
        status = gtk_statusbar_new();
        gtk_statusbar_push(GTK_STATUSBAR(status), 1, global_string);
        gtk_box_pack_start (GTK_BOX (hbox), status, TRUE, TRUE, 10);
        gtk_widget_show(status);
        	
        hbox2 = gtk_hbox_new(FALSE, 0);
        gtk_container_border_width (GTK_CONTAINER (hbox), 0);
        gtk_box_pack_start (GTK_BOX (vbox2), hbox2, FALSE, TRUE, 0);
      	gtk_widget_show(hbox2);
      	
	label2 = gtk_label_new("New: ");
	gtk_box_pack_start (GTK_BOX (hbox2), label2, FALSE, TRUE, 10);
        gtk_widget_show(label2);
			    
	rename_group_value_entry = gtk_entry_new ();
      	gtk_box_pack_start (GTK_BOX (hbox2), rename_group_value_entry, TRUE, TRUE, 10);
        gtk_widget_show(rename_group_value_entry);
        
        hsep = gtk_hseparator_new();
	gtk_box_pack_start (GTK_BOX (vbox), hsep, FALSE, TRUE, 0);
        gtk_widget_show(hsep);
        
        hbox3 = gtk_hbutton_box_new();
        gtk_hbutton_box_set_spacing_default(10);
        gtk_hbutton_box_set_layout_default(GTK_BUTTONBOX_END);
        gtk_box_pack_start (GTK_BOX (vbox), hbox3, FALSE, TRUE, 0);
        gtk_container_border_width (GTK_CONTAINER (hbox3), 10);
      	gtk_widget_show(hbox3);
      		
      	button = gtk_button_new_with_label("OK");
      	gtk_box_pack_start (GTK_BOX (hbox3), button, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (button), "clicked",
			    GTK_SIGNAL_FUNC (ok_rename_group), NULL);
      	gtk_widget_show (button);
      		
      	button2 = gtk_button_new_with_label("Cancel");
      	gtk_box_pack_start (GTK_BOX (hbox3), button2, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (button2), "clicked",
			    GTK_SIGNAL_FUNC (exit_rename_group_window), NULL);
      	gtk_widget_show (button2);
      	
      	button3 = gtk_button_new_with_label("Help");
      	gtk_box_pack_start (GTK_BOX (hbox3), button3, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (button3), "clicked",
			    GTK_SIGNAL_FUNC (help_rename_group_window), NULL);
      	gtk_widget_show (button3);
      	
      	GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
      	gtk_widget_grab_default(button);	
      	rename_group_flag = 1;
      	gtk_widget_show(rename_group_window);
}
/******************************************************************************************/
void edit_group_insert_button()
{
	gint tint, tint2;
    	GList *list, *list2;
	gchar tstring[250], *line[2], *text;
    	extern GtkWidget *edit_group_clist, *edit_group_clist2;
    	extern char *error_message, nothing_selected_edit[], nothing_selected_edit2[];
    	extern display_message();
    	extern int edit_group_size;
    	
	list = GTK_CLIST (edit_group_clist)->selection;
	if (list)
	{
		list2 = GTK_CLIST(edit_group_clist2)->selection;
		if (list2)
		{
			gtk_clist_freeze (GTK_CLIST (edit_group_clist2));
			tint = (int) list->data;
			tint2 = (int) list2->data;
			gtk_clist_get_text (GTK_CLIST (edit_group_clist), tint, 0, &text);
			strcpy(tstring, text);
			strcat(tstring, "\n");
			line[0] = tstring;
			gtk_clist_insert(GTK_CLIST (edit_group_clist2), tint2, line);
			gtk_clist_thaw (GTK_CLIST (edit_group_clist2));
			edit_group_size++;
		}
		else
		{
			error_message = nothing_selected_edit2;
			display_message();
			return;
		}
    	}
    	else
    	{
    		error_message = nothing_selected_edit;
		display_message();
		return;
    	}
}
/******************************************************************************************/
void edit_group_add_button()
{
	gint tint;
    	GList *list;
	gchar tstring[250], *line[2], *text;
    	extern GtkWidget *edit_group_clist, *edit_group_clist2;
    	extern char *error_message, nothing_selected_edit[];
    	extern display_message();
    	extern int edit_group_size;
    	
	list = GTK_CLIST (edit_group_clist)->selection;
	if (list)
	{
		gtk_clist_freeze (GTK_CLIST (edit_group_clist2));
		tint = (int) list->data;
		gtk_clist_get_text (GTK_CLIST (edit_group_clist), tint, 0, &text);
		strcpy(tstring, text);
		strcat(tstring, "\n");
		line[0] = tstring;
		gtk_clist_append(GTK_CLIST (edit_group_clist2), line);
		gtk_clist_thaw (GTK_CLIST (edit_group_clist2));
		edit_group_size++;
    	}
    	else
    	{
    		error_message = nothing_selected_edit;
		display_message();
		return;
    	}
}
/******************************************************************************************/
void edit_group_delete_button()
{
	
    	gint tint;
    	GList *list;
    	extern GtkWidget *edit_group_clist2;
    	extern char *error_message, nothing_selected[];
    	extern display_message();
    	extern int edit_group_size;
    	

	list = GTK_CLIST (edit_group_clist2)->selection;
	if (list)
	{
		gtk_clist_freeze (GTK_CLIST (edit_group_clist2));
		tint = (int) list->data;
		gtk_clist_remove(GTK_CLIST (edit_group_clist2), tint);
		gtk_clist_thaw (GTK_CLIST (edit_group_clist2));
		edit_group_size--;
    	}
    	else
    	{
    		error_message = nothing_selected;
		display_message();
		return;
    	}
}
/****************************************************************************************/
void edit_group_ok_button()
{
	gint tint;
	gchar tstring[250], tstring2[250], *text;
   	FILE *outfile;
   	GList *list;
   	extern GtkWidget *edit_group_clist2;
    	extern int edit_group_size;
    	extern char *edit_groupfilename, *error_message, cant_open_group[];
    	extern exit_edit_group_window(), display_message();
    	
	
	outfile = fopen (edit_groupfilename, "wb");
	if (! outfile)
	{
		error_message = cant_open_group;
		display_message();
		return;
	}
	gtk_clist_freeze (GTK_CLIST (edit_group_clist2));
	for (tint = 0; tint < edit_group_size; tint++)
	{
		gtk_clist_select_row(GTK_CLIST(edit_group_clist2), tint, 0);
		list = GTK_CLIST (edit_group_clist2)->selection;
		gtk_clist_get_text (GTK_CLIST (edit_group_clist2), tint, 0, &text);
		sscanf(text, "%s", tstring2);
		strncpy(tstring, tstring2, GROUP_RECORDSIZE);
		fwrite(tstring, GROUP_RECORDSIZE, 1, outfile);
	}
	gtk_clist_thaw (GTK_CLIST (edit_group_clist2));
	fclose(outfile);
	exit_edit_group_window();
}
/****************************************************************************************/
void ok_edit_group()
{
	struct dirent **dirlist;
    	char tstring[250], tstring2[250], tstring3[250], tstring4[15], tstring5[15], *line[5];
    	char *text[] = {"Group Contents"}, *text2[] = {"Symbol", "Name", "Start", "End"};
    	char *tstringpointer;
	GList *list;
    	int tint, tint2;
    	FILE *infile;
    	unsigned long tlong, records;
    	GtkWidget *vbox, *ok_button, *add_button, *cancel_button, *insert_button, *delete_button;
    	GtkWidget *hbox, *help_button;
    	extern GtkWidget *workwith_groups_clist, *edit_group_window, *new_group_value_entry;
    	extern GtkWidget *edit_group_clist, *edit_group_clist2;
    	extern int edit_group_size, edit_group_flag, new_group_flag;
    	extern char *edit_groupfilename, *error_message, *grouppath, *datapath;
    	extern char nothing_selected[], cant_open_group[], data_missing[];
    	extern display_message(), exit_workwith_groups_window(), exit_edit_group_window();
    	extern help_edit_group_window(), exit_new_group_window();
    
	
	if (edit_group_flag)
		return;
	if (new_group_flag)
	{
		tstringpointer = gtk_entry_get_text(GTK_ENTRY(new_group_value_entry));
		strcpy(tstring2, tstringpointer);
		exit_new_group_window();
	}
	else
	{
    		list = GTK_CLIST (workwith_groups_clist)->selection;
    		if (! list)
    		{
    			error_message = nothing_selected;
			display_message();
			return;
		}
		tint = (int) list->data;
		gtk_clist_get_text (GTK_CLIST (workwith_groups_clist), tint, 0, &tstringpointer);
		strcpy(tstring2, tstringpointer);
	}
	strcpy(tstring, grouppath);
	strcat(tstring, tstring2);
	if (edit_groupfilename != NULL)
       		free(edit_groupfilename);
       	edit_groupfilename = (char*)malloc(strlen(tstring) + 1);
       	strcpy(edit_groupfilename, tstring);
       	infile = fopen (edit_groupfilename, "rb");
       	if (! infile)
       	{
       		error_message = cant_open_group;
		display_message();
		return;
       	}
       	exit_workwith_groups_window();
        	
	edit_group_window = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_signal_connect (GTK_OBJECT (edit_group_window), "delete_event",
		    	    GTK_SIGNAL_FUNC (exit_edit_group_window), NULL);
	gtk_signal_connect (GTK_OBJECT (edit_group_window), "destroy",
		    	    GTK_SIGNAL_FUNC (exit_edit_group_window), NULL);
	gtk_window_position(GTK_WINDOW (edit_group_window), GTK_WIN_POS_CENTER);
	strcpy(tstring, "Edit Group - [");
	strcat(tstring, tstring2);
	strcat(tstring, "]");
	gtk_window_set_title (GTK_WINDOW (edit_group_window), tstring);
	gtk_widget_set_usize(GTK_WIDGET (edit_group_window), 0, 0);
	
	hbox = gtk_hbox_new(FALSE, 10);
       	gtk_container_border_width (GTK_CONTAINER (hbox), 10);
       	gtk_container_add (GTK_CONTAINER (edit_group_window), hbox);
	gtk_widget_show(hbox);
      		
	edit_group_clist = gtk_clist_new_with_titles (4, text2);
	gtk_clist_set_column_width(GTK_CLIST(edit_group_clist), 0, 70);
	gtk_clist_set_column_width(GTK_CLIST(edit_group_clist), 1, 200);
	gtk_clist_set_column_width(GTK_CLIST(edit_group_clist), 2, 70);
	gtk_clist_set_column_width(GTK_CLIST(edit_group_clist), 3, 70);
	gtk_clist_set_selection_mode (GTK_CLIST (edit_group_clist), GTK_SELECTION_SINGLE);
	gtk_clist_set_policy(GTK_CLIST(edit_group_clist),GTK_POLICY_AUTOMATIC,GTK_POLICY_AUTOMATIC);
 	gtk_container_add (GTK_CONTAINER (hbox), edit_group_clist);
      	gtk_container_border_width (GTK_CONTAINER (edit_group_clist), 0);
      	gtk_widget_set_usize(GTK_WIDGET (edit_group_clist), 400, 0);
      	gtk_widget_show (edit_group_clist);
      		
      	vbox = gtk_vbutton_box_new();
      	gtk_container_border_width (GTK_CONTAINER (vbox), 0);
      	gtk_box_pack_start (GTK_BOX (hbox), vbox, FALSE, TRUE, 0);
      	gtk_vbutton_box_set_spacing_default(5);
      	gtk_vbutton_box_set_layout_default(GTK_BUTTONBOX_START);
      	gtk_widget_show (vbox);
      		
      	edit_group_clist2 = gtk_clist_new_with_titles (1, text);
      	gtk_clist_set_selection_mode (GTK_CLIST (edit_group_clist2), GTK_SELECTION_SINGLE);
       	gtk_clist_set_policy(GTK_CLIST(edit_group_clist2),GTK_POLICY_AUTOMATIC,GTK_POLICY_AUTOMATIC);
      	gtk_container_add (GTK_CONTAINER (hbox), edit_group_clist2);
      	gtk_container_border_width (GTK_CONTAINER (edit_group_clist2), 0);
      	gtk_widget_set_usize(GTK_WIDGET (edit_group_clist2), 150, 0);
      	gtk_widget_show (edit_group_clist2);
      		
      	insert_button = gtk_button_new_with_label("Insert");
      	gtk_box_pack_start (GTK_BOX (vbox), insert_button, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (insert_button), "clicked",
			    GTK_SIGNAL_FUNC (edit_group_insert_button), NULL);
      	gtk_widget_show (insert_button);
      		
	add_button = gtk_button_new_with_label("Add");
      	gtk_box_pack_start (GTK_BOX (vbox), add_button, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (add_button), "clicked",
			    GTK_SIGNAL_FUNC (edit_group_add_button), NULL);
      	gtk_widget_show (add_button);
      		
      	delete_button = gtk_button_new_with_label("Delete");
      	gtk_box_pack_start (GTK_BOX (vbox), delete_button, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (delete_button), "clicked",
			    GTK_SIGNAL_FUNC (edit_group_delete_button), NULL);
      	gtk_widget_show (delete_button);
      		
      	ok_button = gtk_button_new_with_label("OK");
      	gtk_box_pack_start (GTK_BOX (vbox), ok_button, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (ok_button), "clicked",
			    GTK_SIGNAL_FUNC (edit_group_ok_button), NULL);
      	gtk_widget_show (ok_button);
      		
      	cancel_button = gtk_button_new_with_label("Cancel");
      	gtk_box_pack_start (GTK_BOX (vbox), cancel_button, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (cancel_button), "clicked",
			    GTK_SIGNAL_FUNC (exit_edit_group_window), NULL);
      	gtk_widget_show (cancel_button);
      	
      	help_button = gtk_button_new_with_label("Help");
      	gtk_box_pack_start (GTK_BOX (vbox), help_button, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (help_button), "clicked",
			    GTK_SIGNAL_FUNC (help_edit_group_window), NULL);
      	gtk_widget_show (help_button);
  		
  	gtk_clist_freeze (GTK_CLIST (edit_group_clist2));
  	fseek(infile, 0L, SEEK_END);
	tlong = ftell(infile);
	edit_group_size = tlong / GROUP_RECORDSIZE;
	fseek(infile, 0L, SEEK_SET);
	for (tint = 0; tint < edit_group_size; tint++)
	{
		fread(tstring, GROUP_RECORDSIZE, 1, infile);
		sscanf(tstring, "%s", tstring2);
        	line[0] = tstring2;
		gtk_clist_append (GTK_CLIST (edit_group_clist2), line);
	}
	gtk_clist_thaw (GTK_CLIST (edit_group_clist2));
	fclose(infile);
		
	gtk_clist_freeze (GTK_CLIST (edit_group_clist));
	tint = scandir(datapath, &dirlist, NULL, alphasort);
	if (tint < 0)
    	{
    		error_message = data_missing;
    		display_message();
    		return;
    	}
	tint2 = tint;
	for (tint = 2; tint < tint2; tint++)
	{
		strcpy(tstring, dirlist[tint]->d_name);
		strcpy(tstring2, datapath);
		strcat(tstring2, tstring);
   		infile = fopen(tstring2, "rb");
   		if (infile)
   		{
   			fread(&tstring, NAME_SIZE, 1, infile);
			line[1] = tstring;
			fread(&tstring2, SYMBOL_SIZE, 1, infile);
			line[0] = tstring2;
			fseek(infile, HEADERSIZE, SEEK_SET);
			fread(&tlong, sizeof(unsigned long), 1, infile);
			sprintf(tstring5, "%ld", tlong);
			tstring3[0] = tstring5[4];
			tstring3[1] = tstring5[5];
			tstring3[2] = '/';
			tstring3[3] = tstring5[6];
			tstring3[4] = tstring5[7];
			tstring3[5] = '/';
			tstring3[6] = tstring5[0];
			tstring3[7] = tstring5[1];
			tstring3[8] = tstring5[2];
			tstring3[9] = tstring5[3];
			tstring3[10] = 0;
			line[2] = tstring3;
			fseek(infile, 0L, SEEK_END);
			tlong = ftell(infile);
			tlong = tlong - HEADERSIZE;
			records = tlong / RECORDSIZE;
			fseek(infile, (long)(((records - 1) * RECORDSIZE) + HEADERSIZE),SEEK_SET);
			fread(&tlong, sizeof(unsigned long), 1, infile);
			sprintf(tstring5, "%ld", tlong);
			tstring4[0] = tstring5[4];
			tstring4[1] = tstring5[5];
			tstring4[2] = '/';
			tstring4[3] = tstring5[6];
			tstring4[4] = tstring5[7];
			tstring4[5] = '/';
			tstring4[6] = tstring5[0];
			tstring4[7] = tstring5[1];
			tstring4[8] = tstring5[2];
			tstring4[9] = tstring5[3];
			tstring4[10] = 0;
			line[3] = tstring4;
			gtk_clist_append (GTK_CLIST (edit_group_clist), line);
			fclose(infile);
		}
	}
	gtk_clist_thaw (GTK_CLIST (edit_group_clist));
	       	
	edit_group_flag = 1;
	gtk_widget_show(edit_group_window);
}
/*****************************************************************************************/
void ok_delete_group()
{
	GList *list;
	int tint;
	char *tstringpointer, tstring[250];
    	extern GtkWidget *workwith_groups_clist, *yesno_window;
    	extern char *error_message, *grouppath, *error_message, *global_string;
    	extern char nothing_selected[];
    	extern display_message(), exit_yesno_window();
    	GtkWidget *hbox, *vbox, *label, *button, *button2, *hsep;
	extern int yesno_flag, global_int;
    	

    	list = GTK_CLIST (workwith_groups_clist)->selection;
    	if (! list)
    	{
    		error_message = nothing_selected;
		display_message();
		return;
	}
	tint = (int) list->data;
	global_int = tint;
	gtk_clist_get_text (GTK_CLIST (workwith_groups_clist),tint,0,&tstringpointer);  
	strcpy(tstring, grouppath);
	strcat(tstring, tstringpointer);
	if (global_string != NULL)
  		free(global_string);
  	global_string = (char *)malloc(sizeof(tstring) + 1);
	strcpy(global_string, tstring);
	
	yesno_window = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_signal_connect (GTK_OBJECT (yesno_window), "delete_event",
			    GTK_SIGNAL_FUNC (exit_yesno_window), NULL);
	gtk_signal_connect (GTK_OBJECT (yesno_window), "destroy",
			    GTK_SIGNAL_FUNC (exit_yesno_window), NULL);
	gtk_window_position(GTK_WINDOW (yesno_window), GTK_WIN_POS_CENTER);
	gtk_window_set_title (GTK_WINDOW (yesno_window), " ");
	gtk_widget_set_usize(GTK_WIDGET (yesno_window), 300, 0);
	
	
	vbox = gtk_vbox_new (FALSE, 10);
	gtk_container_add (GTK_CONTAINER (yesno_window), vbox);
      	gtk_container_border_width (GTK_CONTAINER (vbox), 0);
      	gtk_widget_show (vbox);
      	
      	strcpy(tstring, "Are you sure you want to delete ");
      	strcat(tstring, tstringpointer);
      	strcat(tstring, " ?");
	label = gtk_label_new(tstring);
	gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, TRUE, 10);
        gtk_widget_show(label);
        
        hsep = gtk_hseparator_new();
	gtk_box_pack_start (GTK_BOX (vbox), hsep, FALSE, TRUE, 0);
        gtk_widget_show(hsep);
        
        hbox = gtk_hbutton_box_new();
        gtk_container_border_width (GTK_CONTAINER (hbox), 10);
      	gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, TRUE, 0);
      	gtk_hbutton_box_set_spacing_default(10);
        gtk_hbutton_box_set_layout_default(GTK_BUTTONBOX_END);
      	gtk_widget_show(hbox);
        
      	button = gtk_button_new_with_label("Yes");
      	gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (button), "clicked",
			    GTK_SIGNAL_FUNC (yes_delete_group), NULL);
      	gtk_widget_show (button);
      	
      	button2 = gtk_button_new_with_label("No");
      	gtk_box_pack_start (GTK_BOX (hbox), button2, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (button2), "clicked",
			    GTK_SIGNAL_FUNC (exit_yesno_window), NULL);
      	gtk_widget_show (button2);
      	
      	GTK_WIDGET_SET_FLAGS (button2, GTK_CAN_DEFAULT);
      	gtk_widget_grab_default (button2);
      	yesno_flag = 1;
      	gtk_widget_show(yesno_window);
}
/****************************************************************************************/
void load_group()
{
	gchar tstring[250], *text;
	FILE *infile;
	int tint = 0;
	GList *list;
	long tlong;
    	extern GtkWidget *workwith_groups_clist;
    	extern char *groupfilename, *grouppath, *error_message, *last_group, nothing_selected[];
    	extern char cant_open_group[], group_empty[];
    	extern int group_pointer, group_size, open_file_flag;
    	extern load_file(), display_message(), exit_workwith_groups_window();

	
	list = GTK_CLIST (workwith_groups_clist)->selection;
	if (! list)
	{
		error_message = nothing_selected;
		display_message();
		return;
	}
	tint = (int) list->data;
	gtk_clist_get_text (GTK_CLIST (workwith_groups_clist), tint, 0, &text);  
	strcpy(tstring, grouppath);
	strcat(tstring, text);
	if (groupfilename != NULL)
        	free(groupfilename);
        groupfilename = (char*)malloc(strlen(tstring) + 1);
        strcpy(groupfilename, tstring);
        if (last_group != NULL)
        	free(last_group);
        strcpy(tstring, text);
        last_group = (char*)malloc(strlen(tstring) + 1);
        strcpy(last_group, tstring);
	group_pointer = 0;
	open_file_flag = 0;
	infile = fopen(groupfilename, "rb");
	if (! infile)
	{
		error_message = cant_open_group;
		display_message();
		return;
	}
	fseek(infile, 0L, SEEK_END);
	tlong = ftell(infile);
	group_size = tlong / GROUP_RECORDSIZE;
	fclose(infile);
	if (group_size > 0)
	{
		group_size--;
       		load_file();
       		exit_workwith_groups_window();
	}
	else
	{
		error_message = group_empty;
		display_message();
	}
}
/****************************************************************************************/
void create_group()
{
	gchar tstring[250];
	FILE *infile;
	gchar *infilename;
	extern GtkWidget *new_group_value_entry;
    	extern char *grouppath, *error_message, already_exists[], cant_create[];
    	extern char nothing_entered[];
    	extern display_message(), exit_new_group_window();
	
	
	infilename = gtk_entry_get_text(GTK_ENTRY(new_group_value_entry));
	if (strlen(infilename) != 0)
	{
	       strcpy(tstring, grouppath);
               strcat(tstring, infilename);
	       infile = fopen(tstring, "rb");
	       if (infile)
	       {
	       		fclose(infile);
	       		error_message = already_exists;
			display_message();
			return;
	       }
	       else
	       {
	       		infile = fopen(tstring, "wb");
	       		if (! infile)
	       		{
	       			error_message = cant_create;
				display_message();
				return;
	       		}
	       		fclose(infile);
	       		ok_edit_group();
	       }
	}
	else
	{
		error_message = nothing_entered;
		display_message();
	}
}
/***********************************************************************************/
void new_group()
{
	GtkWidget *vbox, *hbox, *hbox2, *label, *button, *button2, *button3, *hsep;
	extern GtkWidget *new_group_window, *new_group_value_entry;
	extern int new_group_flag;
    	extern exit_new_group_window(), help_new_group_window();
    	
	
	if (new_group_flag)
		return;
	new_group_window = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_signal_connect (GTK_OBJECT (new_group_window), "delete_event",
			    GTK_SIGNAL_FUNC (exit_new_group_window), NULL);
	gtk_signal_connect (GTK_OBJECT (new_group_window), "destroy",
			    GTK_SIGNAL_FUNC (exit_new_group_window), NULL);
	gtk_window_position(GTK_WINDOW (new_group_window), GTK_WIN_POS_CENTER);
	gtk_window_set_title (GTK_WINDOW (new_group_window), "New Group");
	gtk_widget_set_usize(GTK_WIDGET (new_group_window), 300, 0);
	
	vbox = gtk_vbox_new (FALSE, 0);
      	gtk_container_add (GTK_CONTAINER (new_group_window), vbox);
      	gtk_widget_show (vbox);
      	
     	hbox = gtk_hbox_new (FALSE, 10);
      	gtk_container_border_width (GTK_CONTAINER (hbox), 10);
      	gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, TRUE, 0);
      	gtk_widget_show (hbox);
      	
	label = gtk_label_new("New group:");
	gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, TRUE, 0);
        gtk_widget_show(label);
        
	new_group_value_entry = gtk_entry_new ();
     	gtk_box_pack_start (GTK_BOX (hbox), new_group_value_entry, TRUE, TRUE, 0);
        gtk_widget_show(new_group_value_entry);
        
        hsep = gtk_hseparator_new();
	gtk_box_pack_start (GTK_BOX (vbox), hsep, FALSE, TRUE, 0);
        gtk_widget_show(hsep);
        
        hbox2 = gtk_hbutton_box_new();
        gtk_hbutton_box_set_spacing_default(10);
        gtk_hbutton_box_set_layout_default(GTK_BUTTONBOX_END);
        gtk_container_border_width (GTK_CONTAINER (hbox2), 10);
        gtk_box_pack_start (GTK_BOX (vbox), hbox2, FALSE, TRUE, 0);
      	gtk_widget_show(hbox2);
      	
      	button = gtk_button_new_with_label("OK");
      	gtk_box_pack_start (GTK_BOX (hbox2), button, TRUE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (button), "clicked",
			    GTK_SIGNAL_FUNC (create_group), NULL);
	gtk_widget_show (button);
	
	button2 = gtk_button_new_with_label("Cancel");
      	gtk_box_pack_start (GTK_BOX (hbox2), button2, TRUE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (button2), "clicked",
			    GTK_SIGNAL_FUNC (exit_new_group_window), NULL);
      	gtk_widget_show (button2);
      	
      	button3 = gtk_button_new_with_label("Help");
      	gtk_box_pack_start (GTK_BOX (hbox2), button3, TRUE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (button3), "clicked",
			    GTK_SIGNAL_FUNC (help_new_group_window), NULL);
      	gtk_widget_show (button3);
      	
      	GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
      	gtk_widget_grab_default(button);
      	new_group_flag = 1;
      	gtk_widget_show(new_group_window);
}
/****************************************************************************************/
void workwith_groups()
{
	struct dirent **dirlist;
	int tint, tint2;
	gchar *text[] = {"Group Name:"}, *line[1], tstring[250];
	GtkWidget *vbox, *hbox, *open_button, *edit_button, *rename_button, *delete_button;
	GtkWidget *cancel_button, *help_button;
	extern GtkWidget *workwith_groups_window, *workwith_groups_clist;
	extern char *grouppath, group_missing[], *error_message;
	extern int workwith_groups_flag, workwith_charts_flag;
    	extern exit_workwith_groups_window(), help_workwith_groups_window(), display_message();
    	
	if (workwith_groups_flag)
		return;
	if (workwith_charts_flag)
		return;
		
	workwith_groups_window = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_signal_connect (GTK_OBJECT (workwith_groups_window), "delete_event",
			    GTK_SIGNAL_FUNC (exit_workwith_groups_window), NULL);
	gtk_signal_connect (GTK_OBJECT (workwith_groups_window), "destroy",
			    GTK_SIGNAL_FUNC (exit_workwith_groups_window), NULL);
	gtk_window_position(GTK_WINDOW (workwith_groups_window), GTK_WIN_POS_CENTER);
	gtk_window_set_title (GTK_WINDOW (workwith_groups_window), "Work With Groups");
	gtk_container_border_width (GTK_CONTAINER (workwith_groups_window), 0);
	
	hbox = gtk_hbox_new (FALSE, 10);
      	gtk_container_border_width (GTK_CONTAINER (hbox), 10);
      	gtk_container_add (GTK_CONTAINER (workwith_groups_window), hbox);
      	gtk_widget_show (hbox);
      	
      	workwith_groups_clist = gtk_clist_new_with_titles (1, text);
      	gtk_clist_set_selection_mode (GTK_CLIST (workwith_groups_clist), GTK_SELECTION_SINGLE);
       	gtk_clist_set_policy(GTK_CLIST(workwith_groups_clist),GTK_POLICY_AUTOMATIC,GTK_POLICY_AUTOMATIC);
      	gtk_container_add (GTK_CONTAINER (hbox), workwith_groups_clist);
      	gtk_container_border_width (GTK_CONTAINER (workwith_groups_clist), 0);
      	gtk_widget_set_usize(GTK_WIDGET (workwith_groups_clist), 350, 0);
      	gtk_widget_show (workwith_groups_clist);
      	
      	vbox = gtk_vbutton_box_new ();
      	gtk_container_border_width (GTK_CONTAINER (vbox), 0);
      	gtk_box_pack_start (GTK_BOX (hbox), vbox, FALSE, TRUE, 0);
      	gtk_vbutton_box_set_spacing_default(5);
      	gtk_vbutton_box_set_layout_default(GTK_BUTTONBOX_START);
      	gtk_widget_show (vbox);
      	
      	open_button = gtk_button_new_with_label("Open");
      	gtk_box_pack_start (GTK_BOX (vbox), open_button, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (open_button), "clicked",
			    GTK_SIGNAL_FUNC (load_group), NULL);
	gtk_widget_show (open_button);
	
      	edit_button = gtk_button_new_with_label("Edit");
      	gtk_box_pack_start (GTK_BOX (vbox), edit_button, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (edit_button), "clicked",
			    GTK_SIGNAL_FUNC (ok_edit_group), NULL);
	gtk_widget_show (edit_button);
	
      	rename_button = gtk_button_new_with_label("Rename");
      	gtk_box_pack_start (GTK_BOX (vbox), rename_button, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (rename_button), "clicked",
			    GTK_SIGNAL_FUNC (rename_group), NULL);
	gtk_widget_show (rename_button);
	
      	delete_button = gtk_button_new_with_label("Delete");
      	gtk_box_pack_start (GTK_BOX (vbox), delete_button, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (delete_button), "clicked",
			    GTK_SIGNAL_FUNC (ok_delete_group), NULL);
	gtk_widget_show (delete_button);
      	
      	cancel_button = gtk_button_new_with_label("Cancel");
      	gtk_box_pack_start (GTK_BOX (vbox), cancel_button, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (cancel_button), "clicked",
			    GTK_SIGNAL_FUNC (exit_workwith_groups_window), NULL);
      	gtk_widget_show (cancel_button);
      	
      	help_button = gtk_button_new_with_label("Help");
      	gtk_box_pack_start (GTK_BOX (vbox), help_button, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (help_button), "clicked",
			    GTK_SIGNAL_FUNC (help_workwith_groups_window), NULL);
      	gtk_widget_show (help_button);
      	
	gtk_clist_freeze (GTK_CLIST (workwith_groups_clist));
	tint = scandir(grouppath, &dirlist, NULL, alphasort);
	if (tint < 0)
    	{
    		error_message = group_missing;
    		display_message();
    		return;
    	}
	tint2 = tint;
	for (tint = 2; tint < tint2; tint++)
	{
		strcpy(tstring, dirlist[tint]->d_name); 
   		line[0] = tstring;
		gtk_clist_append (GTK_CLIST (workwith_groups_clist), line);
	}
	gtk_clist_thaw (GTK_CLIST (workwith_groups_clist));
      	
      	workwith_groups_flag = 1;
      	gtk_widget_show(workwith_groups_window);
}
/****************************************************************************************/
void load_first_group()
{
	gchar tstring[250];
	FILE *infile;
	long tlong;
    	extern char *groupfilename, *grouppath, *error_message, *last_group, group_empty[];
    	extern int group_pointer, open_file_flag, group_size;
    	extern load_file();
    	extern display_message();
    	

	strcpy(tstring, grouppath);
	strcat(tstring, last_group);
	if (groupfilename != NULL)
       		free(groupfilename);
       	groupfilename = (char*)malloc(strlen(tstring) + 1);
       	strcpy(groupfilename, tstring);
	group_pointer = 0;
      	open_file_flag = 0;
      	infile = fopen(groupfilename, "rb");
      	if (! infile)
		return;
      	fseek(infile, 0L, SEEK_END);
	tlong = ftell(infile);
	group_size = tlong / GROUP_RECORDSIZE;
	group_size--;
	fclose(infile);
	if (group_size > 0)
		load_file();
       	else
       	{
       		error_message = group_empty;
		display_message();
		return;
       	}
}